module HtmlIsIndexForm where
import Html
import HtmlConOps(form,hr,p,txt,input)

isIndexHtml attrs =
    form [ hr, p [txt prompt], p [input "" []], hr ]
  where
    defPrompt = "This is a searchable index. Enter your search keywords below."
    prompt = maybe defPrompt id $ lookupAttr "PROMPT" attrs
